org.cpsolver.studentsct.heuristics

## Class StudentSctNeighbourSelection

- java.lang.Object
- - org.cpsolver.ifs.heuristics.StandardNeighbourSelection<V,T>
  - - org.cpsolver.ifs.heuristics.RoundRobinNeighbourSelection<Request,Enrollment>
    - - org.cpsolver.studentsct.heuristics.StudentSctNeighbourSelection

- All Implemented Interfaces:
    NeighbourSelection<Request,Enrollment>, SolverListener<Request,Enrollment>
  Direct Known Subclasses:
    TwoPhaseStudentSctNeighbourSelection

      public class StudentSctNeighbourSelection
      extends RoundRobinNeighbourSelection<Request,Enrollment>
      implements SolverListener<Request,Enrollment>

  (Batch) student sectioning neighbour selection. It is based on `RoundRobinNeighbourSelection`, the following steps are involved:
  - Phase 1: section all students using incremental branch & bound (no unassignments) (`BranchBoundSelection` is used)
  - Phase 2: pick a student (one by one) with an incomplete schedule, try to find an improvement (`SwapStudentSelection` is used)
  - Phase 3: use standard value selection for some time ( `StandardSelection` is used)
  - Phase 4: use backtrack neighbour selection (`BacktrackSelection` is used)
  - Phase 5: pick a student (one by one) with an incomplete schedule, try to find an improvement, identify problematic students ( `SwapStudentSelection` is used)
  - Phase 6: random unassignment of some problematic students ( `RndUnProblStudSelection` is used)
  - Phase 7: resection incomplete students ( `ResectionIncompleteStudentsSelection` is used)
  - Phase 8: resection of students that were unassigned in step 6 ( `ResectionUnassignedStudentsSelection` is used)
  - Phase 9: pick a student (one by one) with an incomplete schedule, try to find an improvement (`SwapStudentSelection` is used)
  - Phase 10: use standard value selection for some time ( `StandardSelection` with `RouletteWheelRequestSelection` is used)
  - Phase 11: pick a student (one by one) with an incomplete schedule, try to find an improvement (`SwapStudentSelection` is used)
  - Phase 12: use backtrack neighbour selection (`BacktrackSelection` is used)
  - Phase 13: random unassignment of some students ( `RandomUnassignmentSelection` is used)
  Version:
    StudentSct 1.3 (Student Sectioning)
    Copyright (C) 2007 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller

- - ### Field Summary

    - ### Fields inherited from class org.cpsolver.ifs.heuristics.RoundRobinNeighbourSelection

      `iSolver, sLogger`

    - ### Fields inherited from class org.cpsolver.ifs.heuristics.StandardNeighbourSelection

      `iStat`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `StudentSctNeighbourSelection(DataProperties properties)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `changeSelection(int selectionIndex)` Change selection
    `void` | `init(Solver<Request,Enrollment> solver)` Initialization
    `void` | `neighbourFailed(Assignment<Request,Enrollment> assignment, long iteration, Neighbour<Request,Enrollment> neighbour)` Called when `ParallelSolver` failed to assign the given neighbour
    `boolean` | `neighbourSelected(Assignment<Request,Enrollment> assignment, long iteration, Neighbour<Request,Enrollment> neighbour)` A neighbour was selected
    `void` | `setup(Solver<Request,Enrollment> solver)`
    `boolean` | `valueSelected(Assignment<Request,Enrollment> assignment, long iteration, Request variable, Enrollment value)` A value was selected
    `boolean` | `variableSelected(Assignment<Request,Enrollment> assignment, long iteration, Request variable)` A variable was selected

    - ### Methods inherited from class org.cpsolver.ifs.heuristics.RoundRobinNeighbourSelection

      `getSelection, getSelectionIndex, registerSelection, selectNeighbour`

    - ### Methods inherited from class org.cpsolver.ifs.heuristics.StandardNeighbourSelection

      `getValueSelection, getVariableSelection, selectValue, selectVariable, setValueSelection, setVariableSelection`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### StudentSctNeighbourSelection

          public StudentSctNeighbourSelection(DataProperties properties)
                                       throws Exception

      Throws:
        `Exception`

  - ### Method Detail

    - #### init

          public void init(Solver<Request,Enrollment> solver)

      Description copied from class: `RoundRobinNeighbourSelection`
      Initialization
      Specified by:
        `init` in interface `NeighbourSelection<Request,Enrollment>`
      Overrides:
        `init` in class `RoundRobinNeighbourSelection<Request,Enrollment>`
      Parameters:
        `solver` - current solver

    - #### setup

          public void setup(Solver<Request,Enrollment> solver)

    - #### changeSelection

          public void changeSelection(int selectionIndex)

      Description copied from class: `RoundRobinNeighbourSelection`
      Change selection
      Overrides:
        `changeSelection` in class `RoundRobinNeighbourSelection<Request,Enrollment>`
      Parameters:
        `selectionIndex` - current selection index

    - #### variableSelected

          public boolean variableSelected(Assignment<Request,Enrollment> assignment,
                                          long iteration,
                                          Request variable)

      Description copied from interface: `SolverListener`
      A variable was selected
      Specified by:
        `variableSelected` in interface `SolverListener<Request,Enrollment>`
      Parameters:
        `assignment` - current assignment
        `iteration` - current iteration
        `variable` - selected variable
      Returns:
        if false is returned the variable will be discarded (search continues with the next variable selection)

    - #### valueSelected

          public boolean valueSelected(Assignment<Request,Enrollment> assignment,
                                       long iteration,
                                       Request variable,
                                       Enrollment value)

      Description copied from interface: `SolverListener`
      A value was selected
      Specified by:
        `valueSelected` in interface `SolverListener<Request,Enrollment>`
      Parameters:
        `assignment` - current assignment
        `iteration` - current iteration
        `variable` - selected variable
        `value` - selected variable
      Returns:
        if false is returned the selected value is not assigned

    - #### neighbourSelected

          public boolean neighbourSelected(Assignment<Request,Enrollment> assignment,
                                           long iteration,
                                           Neighbour<Request,Enrollment> neighbour)

      Description copied from interface: `SolverListener`
      A neighbour was selected
      Specified by:
        `neighbourSelected` in interface `SolverListener<Request,Enrollment>`
      Parameters:
        `assignment` - current assignment
        `iteration` - current iteration
        `neighbour` - neighbour
      Returns:
        if false is returned the selected neighbour is not assigned

    - #### neighbourFailed

          public void neighbourFailed(Assignment<Request,Enrollment> assignment,
                                      long iteration,
                                      Neighbour<Request,Enrollment> neighbour)

      Description copied from interface: `SolverListener`
      Called when `ParallelSolver` failed to assign the given neighbour
      Specified by:
        `neighbourFailed` in interface `SolverListener<Request,Enrollment>`
      Parameters:
        `assignment` - current assignment
        `iteration` - current iteration
        `neighbour` - neighbour